#-----------------------------------------------------------------------------
# 6/15/07
# Change a MC6 to a PZ2 or other combinations
# by Ockham
#-----------------------------------------------------------------------------

from Tkinter import *
import tkFileDialog
import poser
import os
import string

global SearchList
SearchList=[]

BasePathUncut=poser.AppLocation()
BasePath=BasePathUncut[:(-len('poser.exe'))]
MCPath=os.path.normpath(BasePath+'/runtime/libraries/materials/*.MC6')
MTPath=os.path.normpath(BasePath+'/runtime/libraries/materials/*.MT5')
PZPath=os.path.normpath(BasePath+'/runtime/libraries/pose/*.PZ2')


#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Convert MC6 / MT5 / PZ2")
        self.ChoiceVar = IntVar()
        self.ChoiceVar.set(0) # for figure
        self.FileVar = IntVar()
        self.FileVar.set(0) # for one file

        self.StatusEntry = Entry(self.master,width=70)
        self.StatusEntry.grid(row=0,column=0,columnspan=4)

        Label(self.master, text="Figures:" ).grid(row=1, column=0)
        self.FigsCheck = Radiobutton(self.master,variable=self.ChoiceVar,value=0)
        self.FigsCheck.grid(row=1, column=1)
        Label(self.master, text="Props:" ).grid(row=1, column=2)
        self.PropCheck = Radiobutton(self.master,variable=self.ChoiceVar,value=1)
        self.PropCheck.grid(row=1, column=3)

        Label(self.master, text="One file" ).grid(row=2, column=0)
        self.FigsCheck = Radiobutton(self.master,variable=self.FileVar,value=0)
        self.FigsCheck.grid(row=2, column=1)
        Label(self.master, text="All files" ).grid(row=2, column=2)
        self.PropCheck = Radiobutton(self.master,variable=self.FileVar,value=1)
        self.PropCheck.grid(row=2, column=3)

        # Go/nogo buttons.
        self.button62 = Button(self.master, text="MC6 to PZ2", command=self.Handle6to2)
        self.button62.grid(row=3, column=0,pady=2,padx=2)

        self.button26 = Button(self.master, text="PZ2 to MC6", command=self.Handle2to6)
        self.button26.grid(row=3, column=2,pady=2,padx=2)

        self.button52 = Button(self.master, text="MT5 to PZ2", command=self.Handle5to2)
        self.button52.grid(row=4, column=0,pady=2,padx=2)

        self.button25 = Button(self.master, text="PZ2 to MT5", command=self.Handle2to5)
        self.button25.grid(row=4, column=2,pady=2,padx=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def ShowStatus(self,S): # Just saving repetition
        self.StatusEntry.delete(0,END)
        self.StatusEntry.insert(0,S)
        self.StatusEntry.update_idletasks()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        #if scene: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(100, self.Update)


    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -

    def File2to6(self,Name):
        self.ShowStatus("working on %s" % Name)
        fpIn=open(Name,'rt')
        front,ext=os.path.splitext(Name)
        OutName=front+".MC6"
        fpOut=open(OutName,'wt')

        # Run through and locate the unneeded sections by name.
        # When we encounter one, skip over it.
        while 1:
            st=fpIn.readline()
            if not st: break
            parts=string.split(string.strip(st))
            if (len(parts)==1) and (parts[0] == 'figure'):
                fpOut.write("mtlCollection\n")
            else:
                fpOut.write(st)
        fpIn.close()
        fpOut.close()
        self.ShowStatus("Done with %s." % OutName)

    # - - - - - - - - - - - - - - - - - -

    def One2to6(self):
        fn=tkFileDialog.askopenfilename(initialfile=PZPath, defaultextension=[("PZ2 file", "*.PZ2 *.pz2")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        self.File2to6(fn)

    # - - - - - - - - - - - - - - - - - -

    def All2to6(self):
        global SearchList

        self.ShowStatus("Pick one file in the folder.")
        fn=tkFileDialog.askopenfilename(initialfile=PZPath, defaultextension=[("PZ2 file", "*.PZ2 *.pz2")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        BaseDir,other=os.path.split(fn)
        SearchList = os.listdir(BaseDir)
        if not SearchList: # Not found at all.
            self.ShowStatus("File entry wrong; no PZ2 found.")
            return
        # Get the list of all in folder:
        for fn in SearchList:
            if string.count(string.upper(fn),'.PZ2'):
                name=os.path.join(BaseDir,fn)
                self.File2to6(name)

    # - - - - - - - - - - - - - - - - - -

    def Handle2to6(self): # from the button
        if self.FileVar.get() == 0: # do one
            self.One2to6()
        else:                       # do all
            self.All2to6()

    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -

    def File2to5(self,Name):
        self.ShowStatus("working on %s" % Name)
        fpIn=open(Name,'rt')
        front,ext=os.path.splitext(Name)
        OutName=front+".MT5"
        fpOut=open(OutName,'wt')

        # Run through and locate the unneeded sections by name.
        # When we encounter one, skip over it.
        while 1:
            st=fpIn.readline()
            if not st: break
            parts=string.split(string.strip(st))
            if (len(parts)==1) and (parts[0] == 'figure'):
                fpOut.write("actor $CURRENT\n")
            else:
                fpOut.write(st)
        fpIn.close()
        fpOut.close()
        self.ShowStatus("Done with %s." % OutName)

    # - - - - - - - - - - - - - - - - - -

    def One2to5(self):
        fn=tkFileDialog.askopenfilename(initialfile=PZPath, defaultextension=[("PZ2 file", "*.PZ2 *.pz2")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        self.File2to5(fn)

    # - - - - - - - - - - - - - - - - - -

    def All2to5(self):
        global SearchList

        self.ShowStatus("Pick one file in the folder.")
        fn=tkFileDialog.askopenfilename(initialfile=MCPath, defaultextension=[("PZ2 file", "*.PZ2 *.pz2")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        BaseDir,other=os.path.split(fn)
        SearchList = os.listdir(BaseDir)
        if not SearchList: # Not found at all.
            self.ShowStatus("File entry wrong; no PZ2 found.")
            return
        # Get the list of all in folder:
        for fn in SearchList:
            if string.count(string.upper(fn),'.PZ2'):
                name=os.path.join(BaseDir,fn)
                self.File2to5(name)

    # - - - - - - - - - - - - - - - - - -
    def Handle2to5(self): # from the button
        if self.FileVar.get() == 0: # do one
            self.One2to5()
        else:                       # do all
            self.All2to5()
    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -

    def File5to2(self,Name):
        self.ShowStatus("working on %s" % Name)
        fpIn=open(Name,'rt')
        front,ext=os.path.splitext(Name)
        OutName=front+".PZ2"
        fpOut=open(OutName,'wt')

        # Run through and locate the unneeded sections by name.
        # When we encounter one, skip over it.
        while 1:
            st=fpIn.readline()
            if not st: break
            parts=string.split(string.strip(st))
            if (len(parts)==2) and (parts[0] == 'actor') and (parts[1]=='$CURRENT'):
                if self.ChoiceVar.get() == 0:
                    fpOut.write("figure\n")
                else:
                    fpOut.write("actor $CURRENT\n")
            else:
                fpOut.write(st)
        fpIn.close()
        fpOut.close()
        self.ShowStatus("Done with %s." % OutName)

    # - - - - - - - - - - - - - - - - - -

    def One5to2(self):
        fn=tkFileDialog.askopenfilename(initialfile=MTPath, defaultextension=[("MT5 file", "*.MT5 *.mt5")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        self.File5to2(fn)

    # - - - - - - - - - - - - - - - - - -

    def All5to2(self):
        global SearchList

        self.ShowStatus("Pick one file in the folder.")
        fn=tkFileDialog.askopenfilename(initialfile=MTPath, defaultextension=[("MT5 file", "*.MT5 *.mt5")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        BaseDir,other=os.path.split(fn)
        SearchList = os.listdir(BaseDir)
        if not SearchList: # Not found at all.
            self.ShowStatus("File entry wrong; no MT5 found.")
            return
        # Get the list of all in folder:
        for fn in SearchList:
            if string.count(string.upper(fn),'.MT5'):
                name=os.path.join(BaseDir,fn)
                self.File5to2(name)

    # - - - - - - - - - - - - - - - - - -

    def Handle5to2(self): # from the button
        if self.FileVar.get() == 0: # do one
            self.One5to2()
        else:                       # do all
            self.All5to2()

    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -

    def File6to2(self,Name):
        self.ShowStatus("working on %s" % Name)
        fpIn=open(Name,'rt')
        front,ext=os.path.splitext(Name)
        OutName=front+".PZ2"
        fpOut=open(OutName,'wt')

        # Run through and locate the unneeded sections by name.
        # When we encounter one, skip over it.
        while 1:
            st=fpIn.readline()
            if not st: break
            parts=string.split(string.strip(st))
            if (len(parts)==1) and (parts[0] == 'mtlCollection'):
                if self.ChoiceVar.get() == 0:
                    fpOut.write("figure\n")
                else:
                    fpOut.write("actor $CURRENT\n")
            else:
                fpOut.write(st)
        fpIn.close()
        fpOut.close()
        self.ShowStatus("Done with %s." % OutName)

    # - - - - - - - - - - - - - - - - - -

    def One6to2(self):
        fn=tkFileDialog.askopenfilename(initialfile=MCPath, defaultextension=[("MC6 file", "*.MC6 *.mc6")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        self.File6to2(fn)

    # - - - - - - - - - - - - - - - - - -

    def All6to2(self):
        global SearchList

        self.ShowStatus("Pick one file in the folder.")
        fn=tkFileDialog.askopenfilename(initialfile=MCPath, defaultextension=[("MC6 file", "*.MC6 *.mc6")] )
        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        fn=os.path.abspath(fn)
        BaseDir,other=os.path.split(fn)
        SearchList = os.listdir(BaseDir)
        if not SearchList: # Not found at all.
            self.ShowStatus("File entry wrong; no MC6 found.")
            return
        # Get the list of all in folder:
        for fn in SearchList:
            if string.count(string.upper(fn),'.MC6'):
                name=os.path.join(BaseDir,fn)
                self.File6to2(name)

    # - - - - - - - - - - - - - - - - - -

    def Handle6to2(self): # from the button
        if self.FileVar.get() == 0: # do one
            self.One6to2()
        else:                       # do all
            self.All6to2()

    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------


